// CustomRegistry.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "CustomRegistry.h"

#include "MainFrm.h"
#include "CustomRegistryDoc.h"
#include "CustomRegistryView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomRegistryApp

BEGIN_MESSAGE_MAP(CCustomRegistryApp, CWinApp)
	//{{AFX_MSG_MAP(CCustomRegistryApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomRegistryApp construction

CCustomRegistryApp::CCustomRegistryApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCustomRegistryApp object

CCustomRegistryApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCustomRegistryApp initialization

BOOL CCustomRegistryApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	if (!SetupRegistry())
		return FALSE;

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CCustomRegistryDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CCustomRegistryView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CCustomRegistryApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CCustomRegistryApp message handlers

#include <atlbase.h>

struct _bool_except {};

struct _bool
{
	_bool()
	{
	}
	_bool & operator = ( LONG l )
	{
		if (l != ERROR_SUCCESS)
			throw _bool_except();
		return *this;
	}
};

bool CCustomRegistryApp::SetupRegistry()
{
	TCHAR szKey[ 200 ];
	*szKey = 0;

	::wsprintf( szKey, _T("Software\\%s\\%s\\WebBrowser Settings"),
		::AfxGetApp()->m_pszRegistryKey, ::AfxGetAppName() );

	bool bResult = true;
	_bool b;

	try
	{
		CRegKey key;
		b = key.Create( HKEY_CURRENT_USER, szKey, REG_NONE, REG_OPTION_NON_VOLATILE,
			KEY_WRITE );

		b = key.Create( key.m_hKey, _T("Main"), REG_NONE, REG_OPTION_NON_VOLATILE,
			KEY_WRITE );

		b = key.SetValue( _T("no"), _T("Anchor Underline") );

		b = key.Create( HKEY_CURRENT_USER, szKey, REG_NONE, REG_OPTION_NON_VOLATILE,
			KEY_WRITE );

		b = key.Create( key.m_hKey, _T("Settings"), REG_NONE, REG_OPTION_NON_VOLATILE,
			KEY_WRITE );

		b = key.SetValue( _T("yes"), _T("Use Anchor Hover Color") );

		b = key.SetValue( _T("200,0,200"), _T("Anchor Color Hover") );

		b = key.SetValue( _T("0,0,255"), _T("Anchor Color") );

		b = key.SetValue( _T("128,0,128"), _T("Anchor Color Visited") );

		b = key.SetValue( _T("192,192,192"), _T("Background Color") );

		b = key.SetValue( _T("0,0,0"), _T("Text Color") );
	}
	catch (_bool_except)
	{
		bResult = false;
	}

	return bResult;
}
